unit ex30a;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Bde.DBTables, Vcl.StdCtrls,
  Vcl.ExtCtrls, uCsv_DPXML_Converter, Vcl.ComCtrls, Datasnap.DBClient;

type
  TForm1 = class(TForm)
    Table1: TTable;
    Table1IdClient: TIntegerField;
    Table1NomClient: TStringField;
    Table1PrenomClient: TStringField;
    Table1AdresseClient: TStringField;
    Table1CodePostalClient: TStringField;
    Table1VilleClient: TStringField;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Button3: TButton;
    ListBox2: TListBox;
    ClientDataSet1: TClientDataSet;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  sl1 : TStringList ;
begin
  sl1 := TStringList.Create ;
  table1.Open ;
  while not table1.Eof do
  begin
    sl1.Add (Table1NomClient.Value+' '+Table1PrenomClient.value) ;
    table1.Next ;
  end;
  table1.Close ;
  ListBox1.Items.Text := sl1.Text ;
  sl1.Free ;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  sl1 : TStringList ;
  i1, longueur : integer ;
  st1 : AnsiString ;
  ft1 : TFieldType ;
  mft1 : TMyFieldTypes ;
begin
  sl1 := TStringList.Create ;
  table1.Open ;
  st1 := '' ;
  for i1 := 0 to Table1.FieldDefs.Count - 1 do
  begin
    ft1 := Table1.FieldDefs[i1].DataType ;
    mft1 := aConverter.GetMyFieldTypeFromFieldType(ft1) ;
    st1 := st1+';'+Table1.FieldDefs[i1].Name+':'+ArFormatCSV[mft1] ;
    if ft1 = ftString then
      st1:= st1+inttoStr(Table1.FieldDefs[i1].Size) ;
  end;
  delete (st1,1,1) ;
  sl1.Add (st1) ;
  while not table1.Eof do
  begin
    st1 := '' ;
    for i1 := 0 to Table1.FieldDefs.Count - 1 do
    if Table1.FieldDefs[i1].DataType = ftString then
       st1 := st1+';"'+Table1.Fields[i1].AsString+'"'
    else
       st1 := st1+';'+Table1.Fields[i1].AsString ;
    delete (st1,1,1) ;
    sl1.Add (st1) ;
    table1.Next ;
  end;
  table1.Close ;
  ListBox1.Items.Text := sl1.Text ;
  sl1.SaveToFile('x.txt');
  sl1.Free ;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  sl1 : TStringList ;
  MS1: TMemoryStream;
begin
  sl1 := TStringList.Create ;
  sl1.LoadFromFile('x.txt');
  MS1 := TMemoryStream.create ;
  MS1 := aConverter.TransformToDP(sl1.text, Iso8859_1);
  MS1.Position := 0 ;
  sl1.LoadFromStream(MS1);
  MS1.Free ;

{
  ListBox1.Items.LoadFromFile('x.txt');
  ListBox1.Items.Text := StringReplace(ListBox1.Items.Text,' ','_',[rfReplaceAll]);
  Memo1.Lines.Text := aConverter.slDataXML.Text ;
  // First field must be an identifier
  ClientDataSet1.Fields[0].Visible := false ;
}

  ListBox2.Items.Text := sl1.Text ;
  sl1.Free ;
end;

end.
